<?php
	include_once ("dap-config.php");

	if(file_exists("paypal-function.php")) 
		include ("paypal-function.php"); 
	
	$paypal_sandbox = trim(Dap_Config::get('PAYPAL_SANDBOX'));
	
	if ($paypal_sandbox == "Y")
		define('PAYPAL_SERVER_DAP', "www.sandbox.paypal.com");
	else 
		define('PAYPAL_SERVER_DAP', "www.paypal.com");
	
	logToFile("dap-paypal: paypal_sandbox=" . $paypal_sandbox . ", PAYPAL SERVER=".PAYPAL_SERVER_DAP);
	
	define('TXN_MAX_LENTGH', 16);
	
	$req = 'cmd=_notify-validate';
	foreach ($_REQUEST as $key => $value) {
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
		logToFile("dap-paypal: " . $key . "=" . $value);
	}
	
	logToFile($req);
	$pos = strpos($req, "verify_sign=");
	if($pos == false) {
		logToFile("dap-paypal: Invalid IPN Coming In..:".$req);
		sendAdminEmail("dap-paypal: Invalid IPN Coming In", $req);
		return;
	}
	
	if(file_exists("paypalmultisite.php")) include ("paypalmultisite.php"); 
	
	$paypal_api_login = trim(Dap_Config::get('PAYPAL_API_LOGIN'));
	$paypal_api_password = trim(Dap_Config::get('PAYPAL_API_PASSWORD'));
	
	if (($paypal_api_login != '') && ($paypal_api_password == '')) {
		logToFile("dap-paypal: security key check enabled");
		if (strcmp($_REQUEST['custom'], $paypal_api_login) != 0) {
			
			$msg = "dap-paypal: Rejecting transaction for security reason - Paypal Advanced Variable 'custom' that you set in the Paypal button, should be pointing to your Paypal API Login ID. But the custom variable received in IPN = " . $_REQUEST['custom'] . " does not match the 'Paypal API Login ID = ' " . $paypal_api_login . " that you have set in DAP Config -> Payment Processing -> Paypal API Username";
			
			logToFile($msg);
			logToFile("dap-paypal: rejecting transaction: " . $req);
			sendAdminEmail("dap-paypal: Rejecting transaction for security reason", $msg . ". Transaction Details: " . $req);
			return;
		}
	}
	
	$post = array();
	$post = $_REQUEST;
	
	$txn_num = 0;
	$i=1;
	
	if ($post['custom'] != "") {
		// $params['custom'] = $_REQUEST['item_name'] . "|" . $_REQUEST['coupon_code'];
		$productNameCouponCode = explode("|", $post['custom']);
		
		$itemName =  $productNameCouponCode[0]; // itemName
		$couponCode = $productNameCouponCode[1]; // couponCode
		
		logToFile("dap-paypal: itemName=" . $itemName, LOG_DEBUG_DAP);
		logToFile("dap-paypal: couponCode=" . $couponCode, LOG_DEBUG_DAP);
	}
					
	while (true) {
		$discount_amt = 0;
		if(strcmp($post['txn_type'],"cart") == 0) {
			$post['item_name'] = isset($_REQUEST['item_name' . $i]) ? $_REQUEST['item_name' . $i] : '';
			$post['quantity'] = isset($_REQUEST['quantity' . $i]) ? $_REQUEST['quantity' . $i] : '';
			
			if(isset($post['mc_gross_' . $i]))
				$post['mc_gross'] = $post['mc_gross_' . $i];
	
			if ($post['item_name'] == "") {
				break;
			}
			else if(strcmp($post['payment_type'],"instant") == 0) {
				if (!validateCartForDAPGenBTN($post, $itemName, $couponCode)) {
					$i++;
					$txn_num++;
					continue;
				}
				
				$txn_id = $post['txn_id'];
				
				if((strlen($txn_id) > TXN_MAX_LENTGH) && ($txn_num != 0)) {
					$post['txn_id'] = substr($txn_id, 0, TXN_MAX_LENTGH) . ":" . $txn_num;
					logToFile("dap-paypal: transaction ID truncated txn_id=" . $post['txn_id'], LOG_DEBUG_DAP);
				}
				else {
					$post['txn_id'] =  $txn_id . ":" . $txn_num; 
					logToFile("dap-paypal: transaction ID not truncated txn_id=" . $post['txn_id'], LOG_DEBUG_DAP);
				}
				
				logToFile("dap-paypal: notfication of Paypal Direct Payment, txn_id=" . $post['txn_id'], LOG_DEBUG_DAP);
			}
				//$post['txn_id'] = $post['txn_id'] . "-" . $i;
			processPaypalResponse($req, $post, $i);
			$i++;
			$txn_num++;
		}
		else if(strcmp($post['txn_type'],"subscr_signup") == 0) {
			if(isset($post['mc_amount3'])) {   
				  $post['mc_gross'] = $post['mc_amount3'];
			}
			if(isset($post['mc_amount2'])) {
				  $post['mc_gross'] = $post['mc_amount2'];
			}
			if(isset($post['mc_amount1'])) {  
				  $post['mc_gross'] = $post['mc_amount1'];
			}
			
			processPaypalResponse($req, $post, $i);
			break;
		}
		else if(strcmp($post['txn_type'],"subscr_payment") == 0) {
			$product = Dap_Product::loadProductByName($post['item_name']);
			
			if ($itemName != "") {
				// Check if brand new recurring product purchase or rebill. Use trial price (if set) for price match for new, else use full price
				$transNumFilter = "";
				$emailFilter = $post['payer_email'];
				
				$statusFilter = "";
				
				$product = Dap_Product::loadProductByName(trim($post['item_name']));
		  		$useTrialPrice="Y";
				
				if(isset($product)) {
		  			logToFile("dap-paypal.php: found product=" . $product->getId(), LOG_INFO_DAP);
					$productIdFilter = $product->getId();
					logToFile("dap-paypal: call loadTransactions()", LOG_DEBUG_DAP);
					$TransactionsList = Dap_Transactions::loadTransactions($transNumFilter, $emailFilter, $productIdFilter, $statusFilter);
					
					logToFile("dap-paypal: called loadTransactions()", LOG_DEBUG_DAP);
					
					foreach ($TransactionsList as $transaction) {
						$txn_type = $transaction->getTrans_type();
						$txn_date = $transaction->getDate();
						$today = date("Y-m-d");
						logToFile("dap-paypal: today=" . $today, LOG_DEBUG_DAP);
						logToFile("dap-paypal: txn_date=" . $txn_date, LOG_DEBUG_DAP);
						if ($today != $txn_date) {
							if ($txn_type == "subscr_payment") {
								logToFile("dap-paypal: usetrialprice=N", LOG_DEBUG_DAP);
								$useTrialPrice="N";	
							}
						}
					}
				}
								
				logToFile("dap-paypal: call validateProduct()", LOG_DEBUG_DAP);
				if (!validateProduct($product, $post, $itemName, $couponCode, $useTrialPrice)) {
					logToFile("dap-paypal: validateProduct() validation failed for txn_type=subscr_payment", LOG_DEBUG_DAP);
					return;
				}
			}
				
			processPaypalResponse($req, $post, $i);
			break;
		}
		else if(strcmp($post['txn_type'],"recurring_payment") == 0) {
			if(isset($post['mc_amount3'])) {   
				  $post['mc_gross'] = $post['mc_amount3'];
			}
			if(isset($post['mc_amount2'])) {
				  $post['mc_gross'] = $post['mc_amount2'];
			}
			if(isset($post['mc_amount1'])) {  
				  $post['mc_gross'] = $post['mc_amount1'];
			}
			
			$post['match_description'] = "Y";
			
			if ($itemName != "") {
				if (!validateProduct($product, $post, $itemName, $couponCode)) {
					logToFile("dap-paypal: validateProduct() validation failed for txn_type=recurring_payment", LOG_DEBUG_DAP);
					return;
				}
			}
			
			processPaypalResponse($req, $post, $i);
			break;
		}
		else if(strcmp($post['txn_type'],"recurring_payment_profile_created") == 0) {
			logToFile("dap-paypal: recurring_payment_profile_created - " . $post['txn_id'], LOG_DEBUG_DAP);
			break;
		}
		else if(strcmp($post['txn_type'],"web_accept") == 0) {
			
			logToFile("dap-paypal: in web_accept", LOG_DEBUG_DAP);
			$product = Dap_Product::loadProductByName($post['item_name']);
			logToFile("dap-paypal: got product details", LOG_DEBUG_DAP);
			
			if ($itemName != "") {
				if (!validateProduct($product, $post, $itemName, $couponCode)) {
					logToFile("dap-paypal: validation failed for txn_type=web_accept", LOG_DEBUG_DAP);
					return;
				}
			}
			
			if(strcmp($post['payment_type'],"echeck") == 0) {
				$transNumFilter = "";
				$emailFilter = $post['payer_email'];
				$statusFilter = "";
				$productIdFilter = $product->getId();
				logToFile("dap-paypal: echeck payment: call loadTransactions to see if a pending transaction is already logged", LOG_DEBUG_DAP);
				$TransactionsList = Dap_Transactions::loadTransactions($transNumFilter, $emailFilter, $productIdFilter, $statusFilter);
				
				logToFile("dap-paypal: called loadTransactions()", LOG_DEBUG_DAP);
				
				foreach ($TransactionsList as $transaction) {
					$txn_id = $transaction->getTrans_num();
					logToFile("dap-paypal: found an echeck order with txn_id=". $txn_id, LOG_DEBUG_DAP);
					if(strcmp($post['txn_id'],$txn_id) == 0) {
						$post['txn_id'] = $post['txn_id'] . ":1";
						logToFile("dap-paypal: found an echeck order, updated txn_id=". $post['txn_id'], LOG_DEBUG_DAP);
						break;
					}
				}
			}
			
			processPaypalResponse($req, $post, $i);
			break;
		}
		else {
			if (strcmp($post['txn_type'],"subscr_cancel") == 0) {
				logToFile("dap-paypal: User Cancellation - " . $post['payer_email'] . ", txn_type=" . $post['txn_type'], LOG_DEBUG_DAP);
				sendAdminEmail("User Cancellation", "dap-paypal.php - Customer: " . $post['payer_email'] . " cancelled subscription to Product: " . $post['item_name']);
			}
			return;
		}
		
		logToFile("dap-paypal.php: transaction_type:" . $post['txn_type'] . ", item_name=" . $post['item_name']);
	} //while

	if( $post['coupon_id'] != "") {
		if (!updateUsageById($post['coupon_id'])) {
			logToFile("dap-paypal.php: Failed to update actual usage of coupon code: $coupon_code",LOG_FATAL_DAP);
		}
		logToFile("dap-paypal.php: updated actual usage of coupon code: $coupon_code",LOG_DEBUG_DAP);
	}
	
	logToFile("dap-paypal.php: EXITING...");

	function processPaypalResponse($req, $post, $i) 
	{
		$recurring_profile_notification = "N";
		
		//Lets do some paypal subscription payment clean up 
		if(isset($post['subscr_id']) && !isset($post['txn_id'])) {
			$post['txn_id'] = $post['subscr_id'];
		}
		else if(isset($post['recurring_payment_id']) && (strcmp($post['txn_type'],"recurring_payment_profile_created") == 0)) {
			if (!isset($post['txn_id']))	
				$post['txn_id'] = $post['recurring_payment_id'];
			
			//Get Recurring Profile Details from Paypal
			$recurring_profile_notification = "Y";
			$post_values = array();
			//Merchant info
			$post_values['PWD'] = urlencode(trim(Dap_Config::get('PAYPAL_API_PASSWORD')));
			$post_values['USER'] = urlencode(trim(Dap_Config::get('PAYPAL_API_LOGIN')));
			$post_values['SIGNATURE'] = urlencode(trim(Dap_Config::get('PAYPAL_API_SIGNATURE')));	
			
			$post_values['PROFILEID']=urlencode($post['recurring_payment_id']);
			
			// Convert to proper format for an http post
			$post_string = "&";
			foreach( $post_values as $key => $value ) {
				$post_string .= "$key=" . $value . "&"; 
				logToFile("dap-paypal.php: Get Recurring Profile request params " . $key . "=" . $value	, LOG_DEBUG_DAP);
			}
			$post_string = rtrim( $post_string, "& " );
		
			// Use CURL to establish a connection, submit the post, and record the response.
			//$post_url = "https://test.authorize.net/gateway/transact.dll";
			$methodName = "GetRecurringPaymentsProfileDetails";
				
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, trim(Dap_Config::get('PAYPAL_API_ENDPOINT')));
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
		
			//turning off the server and peer verification(TrustManager Concept).
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
			curl_setopt($ch, CURLOPT_POST, 1);
			$version=VERSION;
			//check if version is included in $nvpStr else include the version.
			if(strlen(str_replace('VERSION=', '', strtoupper($post_string))) == strlen($post_string)) {
				$post_string = "&VERSION=" . urlencode($version) . $post_string;	
			}
		
			$nvpreq="METHOD=".urlencode($methodName).$post_string;
		
			//setting the nvpreq as POST FIELD to curl
			curl_setopt($ch,CURLOPT_POSTFIELDS,$nvpreq);
		
			//getting response from server
			$post_response = curl_exec($ch);
		
			if (curl_errno($ch) == 0) // transaction approved
			{
				// This line takes the response and breaks it into an array using the specified delimiting character
				$response_array=deformatNVP($post_response);
				// The results are output to the screen in the form of an html numbered list.
				foreach ($response_array as $key => $value) {
					logToFile("dap-paypal.php: Paypal Get Recurring Billing Profile Response: key=" . $key . " ,value=" . $value, LOG_DEBUG_DAP);
				}
				/* Display the API response back to the browser.
				  If the response from PayPal was a success, display the response parameters'
				  If the response was an error, display the errors received using APIError.php.
				  */
				curl_close($ch);
				$aresult = array();
				$ack = strtoupper($response_array["ACK"]);
				//if the connection and send worked $response holds the return from Authorize.net
				if (!strcasecmp ($ack,"SUCCESS")) { //SUCCESS
					logToFile("dap-paypal.php: Get Recurring Billing Profile successfully processed by Paypal for PROFILE ID=" . $post['recurring_payment_id'], LOG_DEBUG_DAP);
					// set params
					$post['first_name'] = $response_array['FIRSTNAME'];
					$post['last_name'] = $response_array['LASTNAME'];
					$post['address1'] = $response_array['$STREET'];
					$post['city'] = $response_array['CITY'];
					$post['state'] = $response_array['STATE'];
					$post['zip'] = $response_array['ZIP'];
					$post['country'] = $response_array['COUNTRYCODE'];
					$post['phone'] = $response_array['PHONENUM'];
							
					$post['ship_to_first_name'] = $response_array['SHIPTONAME'];
					$post['ship_to_address1'] = $response_array['SHIPTOSTREET'];
					$post['ship_to_city'] = $response_array['SHIPTOCITY'];
					$post['ship_to_state'] = $response_array['SHIPTOSTATE'];
					$post['ship_to_zip'] = $response_array['SHIPTOZIP'];
					$post['ship_to_country'] = $response_array['SHIPTOCOUNTRYCODE'];
					
					$post['mc_gross'] = $response_array['AMT'];
					$post['mc_currency'] = $response_array['CURRENCYCODE'];
					
					if ( !isset($post['payer_email']) || $post['payer_email'] == '' )
						$post['payer_email'] = $response_array['EMAIL'];
						
					$post['item_name'] = $post['product_name'];
					$post['item_number'] = "1";
				}
				else {
					logToFile("dap-paypal.php - Recurring profile retrieval from DAP -> Paypal for PROFILE ID = " . $post['recurring_payment_id'] . " failed with error code:" . $response_array["L_ERRORCODE0"] . "and error msg=" .  $response_array["L_LONGMESSAGE0"] . ". Please login to your Paypal merchant account, check the recurring payment profile and assign user->product in DAP Manually", LOG_DEBUG_DAP); 
					
					sendAdminEmail("dap-paypal.php - Recurring profile retrieval from DAP -> Paypal for PROFILE ID = " . $post['recurring_payment_id'] . " Failed", "dap-paypal.php - Recurring profile retrieval from DAP -> Paypal for PROFILE ID = " . $post['recurring_payment_id'] . " failed with error code:" . $response_array['L_ERRORCODE0'] . "and error msg=" .  $response_array['L_LONGMESSAGE0'] . ". Please login to your Paypal merchant account, check the recurring payment profile for this PROFILE ID and assign user->product in DAP Manually");
					
					return FALSE;	
				}	
			}
			else
			{
				logToFile("dap-paypal.php: Failed to connect to Paypal", LOG_DEBUG_DAP);
				sendAdminEmail("dap-paypal.php - Paypal connection could not be established to retrieve recurring payment profile of PROFILE ID= " . $post['recurring_payment_id'], "Paypal connection could not be established to Paypal to retrieve recurring payment profile of PROFILE ID= " . 																																	$post['recurring_payment_id'] . ". This recurring payment will have to be managed within the DAP admin manually" );
				return FALSE;
			}
		}
		
		if(!isset($post['mc_gross'])) { 
			$post['mc_gross'] = '0.00';
		}
		if(!isset($post['payment_status'])) { 
			$post['payment_status'] = 'Completed';
		}
		
		logToFile("dap-paypal.php: call record paypal incoming", LOG_DEBUG_DAP);
		$record_id = Dap_PaymentProcessor::recordPaypalIncoming($post);
		logToFile("dap-paypal.php: recorded incoming paypal. id:". $record_id);
		//$original_request = $req;
		// post back to PayPal system to validate
		
		if ($record_id != -1) {
		//	if ($i == 1)
			verify($record_id, $req);
			
			//finally process the transaction
			Dap_Transactions::processTransaction($record_id);
		}
		
		return;
	}
	
	function verify($record_id, $req) {
		logToFile("dap-paypal.php: In verify: record_id: $record_id\nRequest: $req");
		
		$commProtocol = trim(Dap_Config::get('COMM_PROTOCOL'));
	
		if ($commProtocol == "FOPEN")
			callBackFOpen($record_id, $req);
		else
			callBackCurl($record_id, $req);
		
		logToFile("dap-paypal: commProtocol=" . $commProtocol);
	}
	
	function callBackCurl($record_id, $req) {
		$headers = array(
			"POST /cgi-bin/webscr HTTP/1.0",
			"Content-Type: application/x-www-form-urlencoded",
			"Content-Length: " . strlen($req)
			);
		$url = "https://".PAYPAL_SERVER_DAP;
		logToFile("dap-paypal.php: Paypal Verification url:".$url);
		//
		$ch = curl_init();
		if($ch === FALSE) {
			//error with the curl initialization. Lets try plain old sock.
			logToFile("dap-paypal.php: Problem with CURL. Trying fsockopen now...");
			callBackFOpen($req);
			return;
		}
		
		//curl_setopt($ch, CURLOPT_URL,$url);
		
		curl_setopt($ch, CURLOPT_URL,$url . '/cgi-bin/webscr'); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_USERAGENT, $defined_vars['HTTP_USER_AGENT']);	
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $req); 
		
		$res = curl_exec($ch);
	
		if (curl_errno($ch)) {
			$dap_error = curl_error($ch);
			logToFile("HTTP ERROR" . $dap_error);
			sendAdminEmail("Dap Paypal IPN - Error", $dap_error);
			Dap_Transactions::setRecordStatus($record_id, 3);
		} else {
			$status="VERIFIED";
			if (strcmp ($res, "VERIFIED") == 0) {
				// check the payment_status is Completed
				// check that txn_id has not been previously processed
				// check that receiver_email is your Primary PayPal email
				// check that payment_amount/payment_currency are correct
				// process payment
				logToFile("VERIFIED");
				/*logToFile($item_name);
				logToFile($payment_amount);
				logToFile($payer_email);
				logToFile($txn_id);*/
				
				logToFile("set record status");
				
				//record the successful status - see functions_paypal.php for list of status codes.
				Dap_Transactions::setRecordStatus($record_id, 1);
				logToFile("have set record status");
			}
			else if (strcmp ($res, "INVALID") == 0) {
				$status="INVALID";
				// log for manual investigation
				logToFile("INVALID");	
				//record the INVALID error status. Refer to functions_paypal.php to see the list of error codes.
				Dap_Transactions::setRecordStatus($record_id, 2);
			} else {
				$status="UNKNOWN";
				logToFile("UNKNOWN Status of IPN: res: " . $res);
				//record the UNKNOWN error status. Refer to functions_paypal.php to see the list of error codes.
				Dap_Transactions::setRecordStatus($record_id, 4);
				//sendAdminEmail("dap-paypal: Error In IPN Processing", $res);
			}		
			curl_close($ch);
		}
		logToFile("CURL based VERIFICATION status of IPN: STATUS: " . $status);
	}
	
	
	function callBackFOpen($record_id,$req) {
		logToFile("dap-paypal.php: In callBackFOpen now...");
		$header = "";
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		
		$url = "ssl://" . PAYPAL_SERVER_DAP;
		logToFile("dap-paypal.php: FOPEN, Paypal Verification url:".$url);
			
		$fp = fsockopen ($url, 443, $errno, $errstr, 30);
		logToFile($header);
		//sendAdminEmail("dap-paypal: Using FSockOpen", $header);
		logToFile("FP: $fp"); 
		if (!$fp) {
			// HTTP ERROR
			logToFile("callBackFOpen: HTTP ERROR. Could not do fsockopen...");
			//record the communication error status. Refer to functions_paypal.php to see the list of error codes.
			Dap_Transactions::setRecordStatus($record_id, 3);
			$dap_error = "FSock Failed to connect to: ".PAYPAL_SERVER_DAP;
			sendAdminEmail("Dap Paypal IPN - FSockError", $dap_error);
		} else {
			fputs ($fp, $header . $req);
			$status="VERIFIED";
			while (!feof($fp)) {
				$res = fgets ($fp, 1024);
				if (strcmp ($res, "VERIFIED") == 0) {
					// check the payment_status is Completed
					// check that txn_id has not been previously processed
					// check that receiver_email is your Primary PayPal email
					// check that payment_amount/payment_currency are correct
					// process payment
					logToFile("VERIFIED");
			/*		logToFile($item_name);
					logToFile($payment_amount);
					logToFile($payer_email);
					logToFile($txn_id);*/
					//record the successful status - see dap-settings.php for list of status codes.
					Dap_Transactions::setRecordStatus($record_id, 1);
					logToFile("have set record status");
				}
				else if (strcmp ($res, "INVALID") == 0) {
					$status="INVALID";
					// log for manual investigation
					logToFile("INVALID");	
					//record the INVALID error status. Refer to functions_paypal.php to see the list of error codes.
					Dap_Transactions::setRecordStatus($record_id, 2);
				} else {
					$status="UNKNOWN";
					logToFile("Status of IPN: res: " . $res);
					//record the UNKNOWN error status. Refer to functions_paypal.php to see the list of error codes.
					Dap_Transactions::setRecordStatus($record_id, 4);
					//sendAdminEmail("dap-paypal: Error In IPN Processing", $res);
				}
				
			
			}
			
			logToFile("FOPEN based VERIFICATION status of IPN: STATUS: " . $status);
			
			fclose ($fp);
		}
		
	}
	
	
?>