<?php
/* First run this query

ALTER TABLE `dap_products_resources_jn` ADD UNIQUE (
`product_id` ,
`resource_id` ,
`resource_type`
);

*/ 
 
include_once "dap-config.php";
//copy file resources from product 1 to 2.
copyFileResourcesP2P(1,2);



return;

	/* 
		Copy all file resources from one product to another, if not exists in another already.
		This does not copy any email (or other) type of resources.
		
		Params: source product id, destination product id.
		Return: nothing.
	
	*/
	function copyFileResourcesP2P($srcProductId, $destProductId) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			//TODO: check if both source and destination products exists.					
			
			/*
				Lets get all product-resource rows for the src product id.				
			*/
			$sql = "SELECT 
						resource_id, is_free, 
						start_day, end_day, 
						start_date, end_date,
						num_clicks,
						resource_type, status
					FROM
						dap_products_resources_jn prj
					WHERE
						prj.product_id = :productId AND
						prj.resource_type = 'F'";
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':productId', $srcProductId, PDO::PARAM_INT);
			$stmt->execute();
			$results = $stmt->fetchAll(PDO::FETCH_ASSOC);
			//while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
			foreach ($results as $key => $row) {
				//Lets insert into products resources join table.
				try {
					$sql2 = "insert into dap_products_resources_jn
								(product_id, resource_id, is_free, start_day, end_day, 
								start_date, end_date, num_clicks, resource_type, status)
								values(:product_id, :resource_id, :is_free, :start_day, :end_day,
								:start_date, :end_date, :num_clicks, :resource_type, :status)";		
					$stmt2 = $dap_dbh->prepare($sql2);
					$stmt2->bindParam(':product_id', $destProductId, PDO::PARAM_INT);
					$stmt2->bindParam(':resource_id', $row['resource_id'], PDO::PARAM_INT);
					$stmt2->bindParam(':is_free', $row['is_free'], PDO::PARAM_STR);
					$stmt2->bindParam(':start_day', $row['start_day'], PDO::PARAM_INT);
					$stmt2->bindParam(':end_day', $row['end_day'], PDO::PARAM_INT);
					$stmt2->bindParam(':start_date', $row['start_date'], PDO::PARAM_STR);
					$stmt2->bindParam(':end_date', $row['end_date'], PDO::PARAM_STR);
					$stmt2->bindParam(':num_clicks', $row['num_clicks'], PDO::PARAM_INT);
					$stmt2->bindParam(':resource_type', $row['resource_type'], PDO::PARAM_STR);
					$stmt2->bindParam(':status', $row['status'], PDO::PARAM_STR);
					$stmt2->execute();	
				} catch (PDOException $e) {
					logToFile($e->getMessage());
					//throw $e;
				} catch (Exception $e) {
					logToFile($e->getMessage());
					//throw $e;
				}		
			}
			
			$stmt = null;
			$dap_dbh = null;
			//return "<b>SUCCESS: File '" . $file . "' <br/>has been added to this product</b><br/><br/>";
		} catch (PDOException $e1) { 
			logToFile($e1->getMessage(),LOG_FATAL_DAP);
			throw $e1;
		} catch (Exception $e1) {
			logToFile($e1->getMessage(),LOG_FATAL_DAP);
			throw $e1;
		}	
	}

?>
