<?php

/**
 * Builds custom meta boxes
 * for various Page Leads.
 * Code based on:
 * http://www.deluxeblogtips.com/2010/05/howto-meta-box-wordpress.html
 */

$prefix = 'kol_';

$meta_boxes = array();


/**
 * Standard Lead
 */

$meta_boxes[] = array(
	'id' => 'standard_lead',
	'title' => 'Standard Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_standard.php',
	'fields' => array(
		array(
			'type' => 'text',
			'id' => $prefix . 'standard_title',
			'name' => 'Lead Title',
			'desc' => 'The title of your Standard Lead',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'standard_content',
			'name' => 'Lead Content',
			'desc' => 'The content of your Standard Lead (you can use HTML)',
			'width' => '100'
		)
	)
);


/**
 * Column Lead
 */

$meta_boxes[] = array(
	'id' => 'column_lead',
	'title' => 'Column Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_column.php',
	'fields' => array(

		// Column 1

		array(
			'type' => 'heading',
			'name' => 'Column 1',
			'desc' => 'Edit the far left column'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'column_one_title',
			'name' => 'Column title',
			'desc' => 'The title of column 1',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'column_one_content',
			'name' => 'Column content',
			'desc' => 'The content of column 1',
			'width' => '100'
		),

		// Column 2

		array(
			'type' => 'heading',
			'name' => 'Column 2',
			'desc' => 'Edit the middle column'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'column_two_title',
			'name' => 'Column title',
			'desc' => 'The title of column 2',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'column_two_content',
			'name' => 'Column content',
			'desc' => 'The content of column 2',
			'width' => '100'
		),

		// Column 3

		array(
			'type' => 'heading',
			'name' => 'Column 3',
			'desc' => 'Edit the far right column'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'column_three_title',
			'name' => 'Column title',
			'desc' => 'The title of column 2',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'column_three_content',
			'name' => 'Column content',
			'desc' => 'The content of column 3',
			'width' => '100'
		)
	)
);


/**
 * Full Lead
 */

$meta_boxes[] = array(
	'id' => 'full_lead',
	'title' => 'Full Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_full.php',
	'fields' => array(
		array(
			'type' => 'text',
			'id' => $prefix . 'full_title',
			'name' => 'Lead Title',
			'desc' => 'The title of your Full Lead',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'full_content',
			'name' => 'Lead Content',
			'desc' => 'The content of your Full Lead (you can use HTML)',
			'width' => '100'
		)
	)
);


/**
 * Table Lead
 */

$meta_boxes[] = array(
	'id' => 'table_lead',
	'title' => 'Table Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_table.php',
	'fields' => array(
		array(
			'type' => 'text',
			'id' => $prefix . 'table_title',
			'name' => 'Lead Title',
			'desc' => 'The title of your Table Lead',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'table_desc',
			'name' => 'Lead Description',
			'desc' => 'This text will go under the Lead Title',
			'width' => '100'
		),
		array(
			'type' => 'checkbox',
			'id' => $prefix . 'table_light',
			'name' => 'Use Light Color Scheme'
		),

		// Table 1

		array(
			'type' => 'heading',
			'name' => 'Table 1 (Left)',
			'desc' => 'Edit the far left table'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'table_one_title',
			'name' => 'Table title',
			'desc' => 'Table 1 title',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'table_one_content',
			'name' => 'Table content',
			'desc' => 'Table 1 content',
			'width' => '100'
		),

		// Table 2

		array(
			'type' => 'heading',
			'name' => 'Table 2 (Middle)',
			'desc' => 'Edit the (dark) middle table'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'table_two_title',
			'name' => 'Table title',
			'desc' => 'Table 2 title',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'table_two_content',
			'name' => 'Table content',
			'desc' => 'Table 2 content',
			'width' => '100'
		),

		// Table 3

		array(
			'type' => 'heading',
			'name' => 'Table 3 (Right)',
			'desc' => 'Edit the far right table'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'table_three_title',
			'name' => 'Table title',
			'desc' => 'Table 3 title',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'table_three_content',
			'name' => 'Table content',
			'desc' => 'Table 3 content',
			'width' => '100'
		)
	)
);


/**
 * Orb Lead
 */

$meta_boxes[] = array(
	'id' => 'orb_lead',
	'title' => 'Orb Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_orb.php',
	'fields' => array(
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_title',
			'name' => 'Lead Title',
			'desc' => 'The title of your orbs lead',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_desc',
			'name' => 'Lead Description',
			'desc' => 'This text will go under the Lead Title',
			'width' => '100'
		),

		// Orb 1

		array(
			'type' => 'heading',
			'name' => 'Orb 1 (Left)',
			'desc' => 'Edit the far left orb'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_one_headline',
			'name' => 'Headline',
			'desc' => 'Orb 1 headline',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_one_content',
			'name' => 'Description',
			'desc' => 'Orb 1 short description',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'orb_one_outer',
			'name' => 'Outer Content',
			'desc' => 'Any content you want to display outside the orb area',
			'width' => '100'
		),

		// Orb 2

		array(
			'type' => 'heading',
			'name' => 'Orb 2 (Middle)',
			'desc' => 'Edit the middle orb'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_two_headline',
			'name' => 'Headline',
			'desc' => 'Orb 2 headline',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_two_content',
			'name' => 'Description',
			'desc' => 'Orb 2 short description',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'orb_two_outer',
			'name' => 'Outer Content',
			'desc' => 'Any content you want to display outside the orb area',
			'width' => '100'
		),

		// Orb 3

		array(
			'type' => 'heading',
			'name' => 'Orb 3 (Right)',
			'desc' => 'Edit the far right orb'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_three_headline',
			'name' => 'Headline',
			'desc' => 'Orb 3 headline',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'orb_three_content',
			'name' => 'Description',
			'desc' => 'Orb 3 short description',
			'width' => '100'
		),
		array(
			'type' => 'textarea',
			'id' => $prefix . 'orb_three_outer',
			'name' => 'Outer Content',
			'desc' => 'Any content you want to display outside the orb area',
			'width' => '100'
		),
	)
);


/**
 * Ribbon Lead
 */

$meta_boxes[] = array(
	'id' => 'ribbon_lead',
	'title' => 'Ribbon Lead',
	'pages' => array('page'),
	'context' => 'normal',
	'priority' => 'high',
	'lead' => 'lead_ribbon.php',
	'fields' => array(
		array(
			'type' => 'text',
			'id' => $prefix . 'ribbon_title',
			'name' => 'Ribbon Title',
			'desc' => 'The title of your Ribbon Lead',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'ribbon_sub',
			'name' => 'Ribbon Sub-Title',
			'desc' => 'The sub-title of this Lead (appears under the title above)',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'ribbon_text',
			'name' => 'Ribbon Text',
			'desc' => 'The text that will appear in the black ribbon',
			'width' => '100'
		),
		array(
			'type' => 'text',
			'id' => $prefix . 'ribbon_link',
			'name' => 'Ribbon Link',
			'desc' => 'Where do you want the ribbon to link to? (can be left blank)',
			'width' => '100'
		)
	)
);


/**
 * Create a class so we
 * can create as many meta
 * boxes as we want
 */

foreach ($meta_boxes as $meta_box)
{
	$kol_meta_box = new Kol_Meta_Box($meta_box);
}


/**
 * Create meta boxes
 */

class Kol_Meta_Box
{
	protected $_meta_box;

	function __construct($meta_box)
	{
		if(!is_admin()) return;
			$this->_meta_box = $meta_box;

		$current_page = substr(strrchr($_SERVER['PHP_SELF'], '/'), 1, -4);

		if($current_page == 'page' || $current_page == 'page-new' || $current_page == 'post' || $current_page == 'post-new') 		{
			add_action('admin_head', array(&$this, 'kol_add_post_enctype'));
			add_action('admin_head', array(&$this, 'kol_add_unlink_script'));
			add_action('admin_head', array(&$this, 'kol_add_clone_script'));
		}
		add_action('admin_menu', array(&$this, 'kol_add_meta_boxes'));
		add_action('save_post', array(&$this, 'kol_save_meta_boxes'));
	}


	function kol_add_post_enctype()
	{
		echo '
		<script type="text/javascript">
		jQuery(document).ready(function(){
			jQuery("#post").attr("enctype", "multipart/form-data");
			jQuery("#post").attr("encoding", "multipart/form-data");
		});
		</script>';
	}

	function kol_add_unlink_script()
	{
		echo '
		<script type="text/javascript">
		jQuery(document).ready(function($){
			$("a.deletefile").click(function () {
				var parent = jQuery(this).parent(),
					data = jQuery(this).attr("rel"),
					_wpnonce = $("input[name=\'_wpnonce\']").val();

				$.post(
					ajaxurl,
					{action: \'unlink_file\', _wpnonce: _wpnonce, data: data},
					function(response){
						//$("#info").html(response).fadeOut(3000);
						//alert(data.post);
					},
					"json"
				);
				parent.fadeOut("slow");
				return false;
			});
		});
		</script>';
	}

	function kol_add_clone_script()
	{
		echo '
		<script type="text/javascript">
		jQuery(document).ready(function() {
			jQuery(".add").click(function() {
				jQuery("#newimages p:first-child").clone().insertAfter("#newimages p:last").show();
				return false;
			});
			jQuery(".remove").click(function() {
				jQuery(this).parent().remove();
			});
		});
		</script>';
	}


	/**
	 * Adds meta boxes to whatever
	 * post type it is assigned to
	 */

	function kol_add_meta_boxes()
	{
		$this->_meta_box['context'] = empty($this->_meta_box['context']) ? 'normal' : $this->_meta_box['context'];
		$this->_meta_box['priority'] = empty($this->_meta_box['priority']) ? 'high' : $this->_meta_box['priority'];

		$post_id = $_GET['post'] ? $_GET['post'] : $_POST['post_ID'];
		$template_file = get_post_meta($post_id, '_wp_page_template', TRUE);
		
		if($template_file == $this->_meta_box['lead'])
		{
			foreach($this->_meta_box['pages'] as $page)
			{
				add_meta_box($this->_meta_box['id'], $this->_meta_box['title'], array(&$this, 'kol_show_meta_boxes'), $page, $this->_meta_box['context'], $this->_meta_box['priority']);
			}
		}
	}

	function kol_show_meta_boxes()
	{
		global $post;

		echo '<input type="hidden" name="wp_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />'; #be safe
		echo '<table class="form-table">';

		foreach ($this->_meta_box['fields'] as $field)
		{
			$meta = get_post_meta($post->ID, $field['id'], true);

			echo '<tr>';
			switch($field['type'])
			{
				case 'heading':
					echo '<tr><td colspan="2"><h4 style="font-size: 16px; margin-bottom: 3px">', $field['name'], '</h4><p style="border-bottom: 1px dashed #ccc; color: #888; padding-bottom: 10px"><em>', $field['desc'], '</em></p></td></tr>';
				break;

				case 'text':
					echo '<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th><td><input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:' , $field['width'] , '%" />',
						'<br />', $field['desc'], '</td>';
					break;

				case 'textarea':
					echo '<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th><td><textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="7" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>',
						'<br />', $field['desc'], '</td>';
					break;

				case 'checkbox':
					echo '<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th><td><input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' /></td>';
					break;
			}
			echo '</tr>';
		}
		echo '</table>';
	}


	/**
	 * Save all data after performing
	 * security checks
	 */

	function kol_save_meta_boxes($post_id)
	{
		if(!wp_verify_nonce($_POST['wp_meta_box_nonce'], basename(__FILE__)))
		{
			return $post_id;
		}

		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
		{
			return $post_id;
		}

		if('page' == $_POST['post_type'])
		{
			if(!current_user_can('edit_page', $post_id))
			{
				return $post_id;
			}
		}
		
		elseif(!current_user_can('edit_post', $post_id))
		{
			return $post_id;
		}

		foreach($this->_meta_box['fields'] as $field)
		{
			$name = $field['id'];

			$old = get_post_meta($post_id, $name, true);
			$new = $_POST[$field['id']];

			if ($field['type'] == 'textarea')
			{
				$new = $new;
			}

			if($new && $new != $old)
			{
				update_post_meta($post_id, $name, $new);
			}
			
			elseif('' == $new && $old && $field['type'] != 'file' && $field['type'] != 'image')
			{
				delete_post_meta($post_id, $name, $old);
			}
		}
	}
}