<?php

// Include init file. This makes MD work. A working skin is a good skin.

include(THESIS_CUSTOM . '/md/init.php'); #md


// Run theme options

function kol_option($option)
{
	$options = get_option('kol_options');
	if(isset($options[$option]))
		return $options[$option];
	else
		return false;
}


// Load scripts (Thesis 1.8.3 cannot enqueue scripts properly yet. Bummer.)

function md_load_scripts()
{
	echo '<script type="text/javascript" src="' . THESIS_CUSTOM_FOLDER . '/md/js/auto_clear.js"></script>';
}
	add_action('thesis_hook_after_html', 'md_load_scripts');


// Load styles

function md_load_styles()
{
	if(kol_option('fb_on') && is_home())
	{
		wp_register_style('google-fonts', 'http://fonts.googleapis.com/css?family=Lobster');
		wp_enqueue_style('google-fonts');
	}
}
    add_action('wp_print_styles', 'md_load_styles');


// Clear custom template

remove_action('thesis_hook_custom_template', 'thesis_custom_template_sample');


/**************
 * H E A D E R
 */

// Flip nav + logo

remove_action('thesis_hook_before_header','thesis_nav_menu');
add_action('thesis_hook_after_title','thesis_nav_menu');


// Register menus

function md_menus()
{
	register_nav_menus(array(
		'primary' => 'Header Menu',
		'main'=> 'Main Menu'
	));
}
	add_action('init' , 'md_menus');


// Build main nav menu (only if enabled in WP)

function md_nav_area()
{
	global $thesis_design;

	if(has_nav_menu('main'))
	{
	?>
		<div id="nav_area" <?php if($thesis_design->layout['framework'] == 'full-width') { echo 'class="full_width"'; } ?>>
			<?php if($thesis_design->layout['framework'] == 'full-width') { echo '<div class="page">'; } ?>
				<?php if(kol_option('nav_disable_search')) { ?>
					<form id="searchform" method="get" action="<?php bloginfo('home'); ?>/">
						<input type="text" size="23" value="Search" />
					</form>
				<?php } ?>
				<?php
					$walker = new md_custom_walker;

					wp_nav_menu(array(
						'theme_location' => 'main',
						'walker' => $walker
					));
				?>
			<?php if($thesis_design->layout['framework'] == 'full-width') { echo '</div>'; } ?>
		</div>
	<?php
	}
}
	if($thesis_design->layout['framework'] == 'full-width') { add_action('thesis_hook_before_content_area', 'md_nav_area', 1); }
	if($thesis_design->layout['framework'] == 'page') { add_action('thesis_hook_after_header', 'md_nav_area', 1); }


/***********************
 * F E A T U R E  B O X
 */

// Build MD feature box

function md_feature_box()
{
	global $thesis_design;

	if(is_home())
	{
		if(kol_option('fb_on'))
		{
			$fb_optin = kol_option('fb_optin');
			$ribbon_text = kol_option('fb_ribbon_text');
			$ribbon_link = kol_option('fb_ribbon_link');
		?>
			<div id="feature_area" <?php if($thesis_design->layout['framework'] == 'full-width') { echo 'class="full_width"'; } ?>>
				<?php if($thesis_design->layout['framework'] == 'full-width') { echo '<div class="page">'; } ?>
					<div id="feature_box" <?php if($ribbon_text) { echo 'class="spacing"'; } ?>>
						<div class="format_text">
							<?php if($fb_optin) { echo wpautop($fb_optin); } ?>
							<?php if($ribbon_text) { if($ribbon_link) { echo '<a href="' . $ribbon_link . '" class="ribbon">' . $ribbon_text . '</a>'; } else { echo '<span class="ribbon">' . $ribbon_text . '</span>'; } } ?>
						</div>
					</div>
				<?php if($thesis_design->layout['framework'] == 'full-width') { echo '</div>'; } ?>
			</div>
		<?php
		}
	}
}
	if($thesis_design->layout['framework'] == 'full-width') { add_action('thesis_hook_before_content_area', 'md_feature_box', 2); }
	if($thesis_design->layout['framework'] == 'page') { add_action('thesis_hook_after_header', 'md_feature_box', 2); }


/**********
 * B L O G
 */

// Remove comment count after post on homepage

remove_action('thesis_hook_after_post', 'thesis_comments_link');


// Add users Twitter info to byline (only if added in profile)

function md_twitter_byline()
{
	$twitter = get_the_author_meta('md_twitter');

	if($twitter)
	{
	?>
		<a href="http://twitter.com/<?php echo $twitter; ?>" class="twitter_byline">Follow me on Twitter</a>
	<?php
	}
}
	add_action('thesis_hook_byline_item', 'md_twitter_byline');


// Build share box

function md_share()
{
?>
	<ul class="share">
		<li>
			<a href="http://twitter.com/share" class="twitter-share-button" data-url="<?php the_permalink() ?>" data-text="<?php the_title_attribute(); ?>" data-count="vertical" data-via="<?php echo kol_option('share_twitter'); ?>">Tweet</a>
		</li>
		<li>
			<iframe src="http://www.facebook.com/plugins/like.php?href=<?php echo urlencode(get_permalink($post->ID)); ?>&amp;layout=box_count&amp;show_faces=false&amp;width=120&amp;action=like&amp;colorscheme=light" scrolling="no" frameborder="0" allowTransparency="true" style="border:none; overflow:hidden; width:50px; height:63px"></iframe>
		</li>
		<li>
			<g:plusone size="tall" href="<?php the_permalink(); ?>"></g:plusone>
		</li>
	</ul>
<?php
}


// Build float box

function md_float()
{
?>
	<ul class="floater">
		<li>
			<a href="http://twitter.com/share" class="twitter-share-button" data-url="<?php the_permalink() ?>" data-text="<?php the_title_attribute(); ?>" data-count="vertical" data-via="<?php echo kol_option('share_twitter'); ?>">Tweet</a>
		</li>
		<li>
			<iframe src="http://www.facebook.com/plugins/like.php?href=<?php echo urlencode(get_permalink($post->ID)); ?>&amp;layout=box_count&amp;show_faces=false&amp;width=120&amp;action=like&amp;colorscheme=light" scrolling="no" frameborder="0" allowTransparency="true" style="border:none; overflow:hidden; width:50px; height:63px"></iframe>
		</li>
		<li>
			<g:plusone size="tall" href="<?php the_permalink(); ?>"></g:plusone>
		</li>
	</ul>
<?php
}


// Output share boxes

function md_share_blog()
{
	if(kol_option('blog_share'))
	{
		if(!is_page())
		{
			md_share();
			if(is_single())
			{
				md_float();
			}
		}
	}

	if(kol_option('pages_share'))
	{
		if(is_page())
		{
			md_share();
			md_float();
		}
	}
}
	add_action('thesis_hook_after_post', 'md_share_blog');
	add_action('thesis_hook_after_teaser', 'md_share_blog');


// Add share button JS to footer (helps page load)

function md_share_js()
{
	if(kol_option('blog_share') || kol_option('pages_share'))
	{
	?>
		<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>
		<script type="text/javascript">(function(){var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;po.src = 'https://apis.google.com/js/plusone.js';var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);})();</script>
	<?php
	}
}
	add_action('thesis_hook_after_html', 'md_share_js');


// Create author box

function md_author_box()
{
	if(is_single())
	{
		$md_twitter = get_the_author_meta('md_twitter');
		$md_url = get_the_author_meta('user_url');

		if(kol_option('pf_author'))
		{
		?>
			<div id="author_area">
				<div class="author_image">
					<?php echo get_avatar(get_the_author_id(), 80); ?>
				</div>
				<div class="author_info">
					<p><strong>About <?php the_author(); ?></strong><br /><?php the_author_description(); ?></p>
					<?php if(!empty($md_twitter) || !empty($md_url)) { ?>
						<p class="author_meta">
							<?php if($md_twitter) { ?>
								<a href="http://twitter.com/<?php echo $md_twitter; ?>">Follow me on Twitter</a> &middot;
							<?php } ?>
							<?php if($md_url) { ?>
								<a href="<?php echo $md_url; ?>">Visit my website &rarr;</a>
							<?php } ?>
						</p>
					<?php } ?>
				</div>
			</div>
		<?php
		}
	}
}
	add_action('thesis_hook_after_post','md_author_box');


// Create custom post footer (only if enabled in MD options)

function md_post_footer()
{
	$pf_headline = kol_option('pf_headline');
	$pf_headline_link = kol_option('pf_headline_link');
	$pf_content = kol_option('pf_content');

	if(is_single())
	{
		if(!empty($pf_headline) || !empty($pf_content))
		{
		?>
			<div class="post_box post_footer">
				<?php if($pf_headline) { ?>
					<div class="headline_area">
						<?php if($pf_headline_link) { ?>
							<h2><a href="<?php echo $pf_headline_link; ?>"><?php echo $pf_headline; ?></a></h2>
						<?php } else { ?>
							<h2><?php echo $pf_headline; ?></h2>
						<?php } ?>
					</div>
				<?php } ?>
				<?php if($pf_content) { ?>
					<div class="format_text">
						<?php echo wpautop($pf_content); ?>
					</div>
				<?php } ?>
			</div>
		<?php
		}
	}
}
	add_action('thesis_hook_after_post_box', 'md_post_footer');


// Build pagination

function md_blog_pagination()
{
	include('functions/pagination.php');
	md_blog_pagination_build();
}
	remove_action('thesis_hook_after_content', 'thesis_post_navigation');
	add_action('thesis_hook_after_content', 'md_blog_pagination');


/**************
 * F O O T E R
 */

// Remove Thesis attribution (don't worry, I put it back)

remove_action('thesis_hook_footer', 'thesis_attribution');


// Build footer

function md_footer()
{
	$thesis_attr = kol_option('foot_disable_thesis_attr');
	$kol_attr = kol_option('foot_disable_kol_attr');
	$foot_content = kol_option('foot_content');
?>
	<?php if(kol_option('fat_footer') == 1) { ?>
		<?php if(!is_page_template('page_landing.php')) { ?>
			<div id="fat_footer">
				<div class="column_wrap">
					<?php if(!function_exists('dynamic_sidebar') || !dynamic_sidebar('Footer Column 1')); ?>
				</div>
				<div class="column_wrap">
					<?php if(!function_exists('dynamic_sidebar') || !dynamic_sidebar('Footer Column 2')); ?>
				</div>
				<div class="column_wrap last">
					<?php if(!function_exists('dynamic_sidebar') || !dynamic_sidebar('Footer Column 3')); ?>
				</div>
			</div>
		<?php } ?>
	<?php } ?>
	<div id="footer_copy">
		<?php
			if($kol_attr == 0 || $thesis_attr == 0)
			{
			?>
				<span>
					<?php
						if($thesis_attr == 0) { echo 'Built on <a href="' . kol_option('foot_thesis_link') . '">Thesis</a>.'; }
						if($kol_attr == 0) { echo '&nbsp;&nbsp;<a href="http://kolakube.com/skins/">Thesis skins by Kolakube</a>.'; }
					?>
				</span>
			<?php
			}
		?>
		<?php echo wpautop($foot_content); ?>
	</div>
<?php
}
	add_action('thesis_hook_footer', 'md_footer');

	if(kol_option('fat_footer') == 1) {
	register_sidebar(array(
		'name' => 'Footer Column 1',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'=>'<h3>',
		'after_title'=>'</h3>'
	));

	register_sidebar(array(
		'name' => 'Footer Column 2',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'=>'<h3>',
		'after_title'=>'</h3>'
	));

	register_sidebar(array(
		'name' => 'Footer Column 3',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'=>'<h3>',
		'after_title'=>'</h3>'
	));
	}