<?php

/**
 * Template Name: Page Lead - Columns
 */

	global $thesis_design;

	$page_title = get_the_title();

	$column_one_title = get_post_meta($post->ID, 'kol_column_one_title', true);
	$column_one_content = get_post_meta($post->ID, 'kol_column_one_content', true);

	$column_two_title = get_post_meta($post->ID, 'kol_column_two_title', true);
	$column_two_content = get_post_meta($post->ID, 'kol_column_two_content', true);

	$column_three_title = get_post_meta($post->ID, 'kol_column_three_title', true);
	$column_three_content = get_post_meta($post->ID, 'kol_column_three_content', true);

	echo apply_filters('thesis_doctype', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">') . "\n";

?>

<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>

<?php
	wp_enqueue_style('page-lead', THESIS_CUSTOM_FOLDER . '/md/css/lead_column.css'); #marketers delight
	thesis_head::build();
	echo '<body' . thesis_body_classes() . ' id="page_lead">' . "\n";
	thesis_hook_before_html();
?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?> 
		<div id="header_area" class="full_width">
			<div class="page">
				<?php thesis_header_area(); ?>
			</div>
		</div>
		<?php thesis_hook_before_content_area(); ?>
		<div id="content_area" class="full_width">
			<div class="page">
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'page') { ?> 
		<div id="container">
			<div id="page">
				<?php thesis_header_area(); ?>
	<?php } ?>

				<div id="lead_wrapper">
					<div id="column_lead">
						<div class="format_text">
							<?php if($column_one_title) { echo '<h3>' . $column_one_title . '</h3>'; } ?>
							<?php if($column_one_content) { echo wpautop($column_one_content); } ?>
						</div>
						<div class="format_text">
							<?php if($column_two_title) { echo '<h3>' . $column_two_title . '</h3>'; } ?>
							<?php if($column_two_content) { echo wpautop($column_two_content); } ?>
						</div>
						<div class="format_text no_spacing">
							<?php if($column_three_title) { echo '<h3>' . $column_three_title . '</h3>'; } ?>
							<?php if($column_three_content) { echo wpautop($column_three_content); } ?>
						</div>
					</div>
				</div>
				<div id="content_box" class="no_sidebars">
					<div id="content">
						<div id="post-<?php the_ID(); ?>" class="post_box top">
							<?php if(have_posts()) : while (have_posts()) : the_post(); ?>
							<?php if($page_title) { ?>
								<div class="headline_area">
									<?php echo '<h2>' . $page_title . '</h2>'; ?>
								</div>
							<?php } else { } ?>
							<div class="format_text">
								<?php the_content(); ?>
								<?php md_float(); ?>
							</div>
							<?php endwhile; else: ?>
							<?php endif; ?>
						</div>
					</div>
				</div>
	<?php if($thesis_design->layout['framework'] == 'page') { ?>
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
			</div>
		</div>
		<div id="footer_area" class="full_width">
			<div class="page">
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

<?php
	thesis_ie_clear();
	thesis_javascript::output_scripts();
	thesis_hook_after_html(); #hook
	echo "</body>\n</html>";