<?php

/**
 * Template Name: Page Lead - Full-Page
 */

	global $thesis_design;

	$page_title = get_the_title();

	$full_title = get_post_meta($post->ID, 'kol_full_title', true);
	$full_content = get_post_meta($post->ID, 'kol_full_content', true);

	echo apply_filters('thesis_doctype', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">') . "\n";

?>

<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>

<?php
	wp_enqueue_style('page-lead', THESIS_CUSTOM_FOLDER . '/md/css/lead_full.css'); #marketers delight
	thesis_head::build();
	echo '<body' . thesis_body_classes() . ' id="page_lead">' . "\n";
	thesis_hook_before_html();
?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?> 
		<div id="header_area" class="full_width">
			<div class="page">
				<?php thesis_header_area(); ?>
			</div>
		</div>
		<?php thesis_hook_before_content_area(); ?>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'page') { ?> 
		<div id="container">
			<div id="page">
				<?php thesis_header_area(); ?>
	<?php } ?>

	<div id="full_lead" <?php if($thesis_design->layout['framework'] == 'full-width') { echo 'class="full_width"'; } ?>>
		<?php if($thesis_design->layout['framework'] == 'full-width') { echo '<div class="page">'; } ?>
			<div id="full_wrapper">
				<?php if($full_title) { echo '<h1>' . $full_title . '</h1>'; } ?>
				<?php if($full_content) { ?>
					<div class="format_text">
						<?php echo wpautop($full_content); ?>
					</div>
				<?php } ?>
			</div>
		<?php if($thesis_design->layout['framework'] == 'full-width') { echo '</div>'; } ?>
	</div>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
		<div id="content_area" class="full_width">
			<div class="page">
	<?php } ?>

				<div id="content_box" class="no_sidebars">
					<div id="content">
						<div id="post-<?php the_ID(); ?>" class="post_box top">
							<?php if(have_posts()) : while (have_posts()) : the_post(); ?>
							<?php if($page_title) { ?>
								<div class="headline_area">
									<?php echo '<h2>' . $page_title . '</h2>'; ?>
								</div>
							<?php } else { } ?>
							<div class="format_text">
								<?php the_content(); ?>
								<?php md_share(); ?>
							</div>
							<?php endwhile; else: ?>
							<?php endif; ?>
						</div>
					</div>
				</div>
	<?php if($thesis_design->layout['framework'] == 'page') { ?>
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
			</div>
		</div>
		<div id="footer_area" class="full_width">
			<div class="page">
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

<?php
	thesis_ie_clear();
	thesis_javascript::output_scripts();
	thesis_hook_after_html(); #hook
	echo "</body>\n</html>";