<?php

/**
 * Template Name: Page Lead - Orbs
 */

	global $thesis_design;

	$page_title = get_the_title();

	$orb_title = get_post_meta($post->ID, 'kol_orb_title', true);
	$orb_desc = get_post_meta($post->ID, 'kol_orb_desc', true);

	$orb_one_headline = get_post_meta($post->ID, 'kol_orb_one_headline', true);
	$orb_one_content = get_post_meta($post->ID, 'kol_orb_one_content', true);
	$orb_one_outer = get_post_meta($post->ID, 'kol_orb_one_outer', true);

	$orb_two_headline = get_post_meta($post->ID, 'kol_orb_two_headline', true);
	$orb_two_content = get_post_meta($post->ID, 'kol_orb_two_content', true);
	$orb_two_outer = get_post_meta($post->ID, 'kol_orb_two_outer', true);

	$orb_three_headline = get_post_meta($post->ID, 'kol_orb_three_headline', true);
	$orb_three_content = get_post_meta($post->ID, 'kol_orb_three_content', true);
	$orb_three_outer = get_post_meta($post->ID, 'kol_orb_three_outer', true);

	echo apply_filters('thesis_doctype', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">') . "\n";

?>

<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>

<?php
	wp_enqueue_style('page-lead', THESIS_CUSTOM_FOLDER . '/md/css/lead_orbs.css'); #marketers delight
	thesis_head::build();
	echo '<body' . thesis_body_classes() . ' id="page_lead">' . "\n";
	thesis_hook_before_html();
?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?> 
		<div id="header_area" class="full_width">
			<div class="page">
				<?php thesis_header_area(); ?>
			</div>
		</div>
		<?php thesis_hook_before_content_area(); ?>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'page') { ?> 
		<div id="container">
			<div id="page">
				<?php thesis_header_area(); ?>
	<?php } ?>

	<div id="orb_lead" <?php if($thesis_design->layout['framework'] == 'full-width') { echo 'class="full_width"'; } ?>>
		<?php if($thesis_design->layout['framework'] == 'full-width') { echo '<div class="page">'; } ?>
			<div id="lead_wrapper">
				<?php if($orb_title) { echo '<h1>' . $orb_title . '</h1>'; } ?>
				<?php if($orb_desc) { echo '<p class="sub">' . $orb_desc . '</p>'; } ?>
				<div class="format_text">
					<div class="orb">
						<div class="orb_content">
							<?php if($orb_one_headline) { echo '<h3>' . $orb_one_headline . '</h3>'; } ?>
							<?php if($orb_one_content) { echo '<p>' . $orb_one_content . '</p>'; } ?>
						</div>
					</div>
					<?php if($orb_one_outer) { echo wpautop($orb_one_outer); } ?>
				</div>
				<div class="format_text">
					<div class="orb">
						<div class="orb_content">
							<?php if($orb_two_headline) { echo '<h3>' . $orb_two_headline . '</h3>'; } ?>
							<?php if($orb_two_content) { echo '<p>' . $orb_two_content . '</p>'; } ?>
						</div>
					</div>
					<?php if($orb_two_outer) { echo wpautop($orb_two_outer); } ?>
				</div>
				<div class="format_text no_spacing">
					<div class="orb">
						<div class="orb_content">
							<?php if($orb_three_headline) { echo '<h3>' . $orb_three_headline . '</h3>'; } ?>
							<?php if($orb_three_content) { echo '<p>' . $orb_three_content . '</p>'; } ?>
						</div>
					</div>
					<?php if($orb_three_outer) { echo wpautop($orb_three_outer); } ?>
				</div>
			</div>
		<?php if($thesis_design->layout['framework'] == 'full-width') { echo '</div>'; } ?>
	</div>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
		<div id="content_area" class="full_width">
			<div class="page">
	<?php } ?>

				<div id="content_box" class="no_sidebars">
					<div id="content">
						<div id="post-<?php the_ID(); ?>" class="post_box top">
							<?php if(have_posts()) : while (have_posts()) : the_post(); ?>
							<?php if($page_title) { ?>
								<div class="headline_area">
									<?php echo '<h2>' . $page_title . '</h2>'; ?>
								</div>
							<?php } else { } ?>
							<div class="format_text">
								<?php the_content(); ?>
								<?php md_float(); ?>
							</div>
							<?php endwhile; else: ?>
							<?php endif; ?>
						</div>
					</div>
				</div>
	<?php if($thesis_design->layout['framework'] == 'page') { ?>
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
			</div>
		</div>
		<div id="footer_area" class="full_width">
			<div class="page">
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

<?php
	thesis_ie_clear();
	thesis_javascript::output_scripts();
	thesis_hook_after_html(); #hook
	echo "</body>\n</html>";