<?php

/**
 * Template Name: Contact Page
 */

global $thesis_design;

echo apply_filters('thesis_doctype', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">') . "\n";
?>
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
<?php
	wp_enqueue_style('contact', THESIS_CUSTOM_FOLDER . '/md/css/page_contact.css'); #marketers delight
	thesis_head::build();
	wp_enqueue_script('contact_load', THESIS_CUSTOM_FOLDER . '/md/js/contact_js.js', '', '', true); #marketers delight
	wp_enqueue_script('contact_validate', THESIS_CUSTOM_FOLDER . '/md/js/contact_validate.js', '', '', true); #marketers delight
	include(THESIS_CUSTOM . '/md/functions/contact_form.php'); #marketers delight

	echo "<body" . thesis_body_classes() . ">\n";
	thesis_hook_before_html();
?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?> 
		<div id="header_area" class="full_width">
			<div class="page">
				<?php thesis_header_area(); ?>
			</div>
		</div>
		<?php thesis_hook_before_content_area(); ?>
		<div id="content_area" class="full_width">
			<div class="page">
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'page') { ?> 
		<div id="container">
			<div id="page">
				<?php thesis_header_area(); ?>
	<?php } ?>

				<div id="content_box">
					<div id="contact_area">
						<div id="contact_info">
							<?php if(have_posts()) : while (have_posts()) : the_post(); ?>
							<div class="headline_area">
								<h1><?php the_title(); ?></h1>
							</div>
							<div class="format_text">
								<?php the_content(); ?>
							</div>
							<?php endwhile; else: ?>
							<?php endif; ?>
						</div>
						<div id="contact_form">
							<div class="format_text">
								<?php if(isset($emailSent) && $emailSent == true) { ?>
									<p class="thanks">Thanks, your email was sent successfully. We will get back to your shortly!</p>
								<?php } else { ?>
								<form action="<?php the_permalink(); ?>" id="contactForm" method="post">
									<p class="half_input">
										<label for="contactName">Your name: <?php if($nameError != '') { ?><span class="error"><?=$nameError;?></span><?php } ?></label>
										<input type="text" name="contactName" id="contactName" value="<?php if(isset($_POST['contactName'])) echo $_POST['contactName'];?>" class="required requiredField" />
									</p>
									<p class="half_input last_input">
										<label for="email">Your email: <?php if($emailError != '') { ?><span class="error"><?=$emailError;?></span><?php } ?></label>
										<input type="text" name="email" id="email" value="<?php if(isset($_POST['email']))  echo $_POST['email'];?>" class="required requiredField" />
									</p>
									<p class="full_textarea">
										<label for="commentsText">Your message: <?php if($commentError != '') { ?><span class="error"><?=$commentError;?></span><?php } ?></label>
										<textarea name="comments" id="commentsText" rows="7" cols="30" class="required requiredField"><?php if(isset($_POST['comments'])) { if(function_exists('stripslashes')) { echo stripslashes($_POST['comments']); } else { echo $_POST['comments']; } } ?></textarea>
									</p>
									<p>
										<input type="submit" class="gray button" id="submit_message" value="Send Message Now"></input>
									</p>
									<input type="hidden" name="submitted" id="submitted" value="true" />
								</form>
								<?php } ?>
							</div>
						</div>
					</div>
				</div>

	<?php if($thesis_design->layout['framework'] == 'page') { ?>
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
			</div>
		</div>
		<div id="footer_area" class="full_width">
			<div class="page">
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

<?php
	thesis_ie_clear();
	thesis_javascript::output_scripts();
	thesis_hook_after_html(); #hook
	echo "</body>\n</html>";