<?php
/**
 * Template Name: Landing Page
 */

global $thesis_design;

$foot_content = kol_option('foot_content');

echo apply_filters('thesis_doctype', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">') . "\n";
?>
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
<?php
	wp_enqueue_style('landing', THESIS_CUSTOM_FOLDER . '/md/css/page_landing.css'); #marketers delight
	thesis_head::build();
	echo "<body" . thesis_body_classes() . ">\n";
	thesis_hook_before_html();
?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?> 
		<div id="header_area" class="full_width">
			<div class="page">
				<div id="header">
					<p id="logo"><a href="<?php bloginfo('url'); ?>"><?php bloginfo('name'); ?></a></p>
				</div>
			</div>
		</div>
		<div id="content_area" class="full_width">
			<div class="page">
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'page') { ?> 
		<div id="container">
			<div id="page">
				<div id="header">
					<p id="logo"><a href="<?php bloginfo('url'); ?>"><?php bloginfo('name'); ?></a></p>
				</div>
	<?php } ?>

		<div id="content_box" class="no_sidebars">
			<div id="content">
				<div id="post-<?php the_ID(); ?>" class="post_box top">
					<?php if(have_posts()) : while (have_posts()) : the_post(); ?>
					<?php thesis_headline_area(); ?>
					<div class="format_text">
						<?php md_share(); ?>
						<?php the_content(); ?>
					</div>
					<?php endwhile; else: ?>
					<?php endif; ?>
				</div>
			</div>
		</div>

	<?php if($thesis_design->layout['framework'] == 'page') { ?>
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

	<?php if($thesis_design->layout['framework'] == 'full-width') { ?>
			</div>
		</div>
		<div id="footer_area" class="full_width">
			<div class="page">
				<?php thesis_footer_area(); ?>
			</div>
		</div>
	<?php } ?>

<?php
	thesis_ie_clear();
	thesis_javascript::output_scripts();
	thesis_hook_after_html(); #hook
	echo "</body>\n</html>";